#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Button.H>
#include <iostream>
using namespace std;

/*  Compile with: fltk-config --compile keyup.cc  */
/*  Hold a key ('a',etc.) for several seconds, and look out for some FL_KEYUP which come out before the key is released */
class MyButton : public Fl_Button
{
     static int count;
public:
     MyButton(int x,int y,int w,int h,const char*l=0)
     :Fl_Button(x,y,w,h,l) {}
            
     int handle(int e)
     {
         int ret = Fl_Button::handle(e);

	 if    (e==FL_KEYDOWN) { cout<< count++<<": FL_KEYDOWN"<<endl; }
	 else if (e==FL_KEYUP) { cout<< count++<<": FL_KEYUP"<<endl; };

	 return ret;
     }
     
};

int MyButton::count=0;

int main()
{
    Fl_Window win(120,80);
    win.begin();

    MyButton but_a(10,10,100,25,"A");
    but_a.shortcut('a');

    win.end();
    win.show();
    return(Fl::run());
}
